Index: binaries/data/config/default.cfg
===================================================================
--- binaries/data/config/default.cfg	(revision 13821)
+++ binaries/data/config/default.cfg	(working copy)
@@ -17,6 +17,11 @@
 ; *                                                            *
 ; **************************************************************
 
+; Game version data
+versionNumber = 14
+versionNumberString = "XIV"
+versionName = "Naukratis"
+
 ; Enable/disable windowed mode by default. (Use Alt+Enter to toggle in the game.)
 windowed = false
 
Index: binaries/data/mods/public/gui/pregame/mainmenu.xml
===================================================================
--- binaries/data/mods/public/gui/pregame/mainmenu.xml	(revision 13821)
+++ binaries/data/mods/public/gui/pregame/mainmenu.xml	(working copy)
@@ -440,17 +440,18 @@
 
 				<!-- PRE-RELEASE WARNING -->
 				<object
+					name="preReleaseWarning"
 					font="serif-14"
 					type="text"
 					textcolor="white"
 					size="8 8 100%-8 100%-36"
                                         ghost="true"
 				>
-[font="serif-bold-16"]Alpha XIV: Naukratis<!-- IMPORTANT: remember to update session/session.xml in sync with this -->[/font]
-
-WARNING: This is an early development version of the game. Many features have not been added yet.
-
-Get involved at: play0ad.com
+				<action on="Load">
+					this.caption = "[font=\"serif-bold-16\"]Alpha " + Engine.GetVersionNumberString() + " : " + Engine.GetVersionName() + "[/font]\n\n" +
+					"WARNING: This is an early development version of the game. Many features have not been added yet.\n\n" +
+					"Get involved at: play0ad.com"
+				</action>
 				</object>
 
 				<!-- FUNDRAISER -->
Index: binaries/data/mods/public/gui/session/session.xml
===================================================================
--- binaries/data/mods/public/gui/session/session.xml	(revision 13821)
+++ binaries/data/mods/public/gui/session/session.xml	(working copy)
@@ -615,7 +615,7 @@
 
 	    <!-- Displays Alpha name and number -->
 	    <object size="50%+48 0 100%-226 100%" name="alphaLabel" type="text" style="CenteredLabelText" text_valign="top" ghost="true">
-		ALPHA XIV : Naukratis<!-- IMPORTANT: remember to update pregame/mainmenu.xml in sync with this -->
+			<action on="Load">this.caption= "Alpha " + Engine.GetVersionNumberString() + " : " + Engine.GetVersionName()</action>
 
 		<!-- Displays build date and revision number-->
 		<object size="50%-128 0 50%+128 100%-2" name="buildTimeLabel" type="text" style="BuildNameText" ghost="true">
Index: source/gui/scripting/ScriptFunctions.cpp
===================================================================
--- source/gui/scripting/ScriptFunctions.cpp	(revision 13821)
+++ source/gui/scripting/ScriptFunctions.cpp	(working copy)
@@ -537,7 +537,28 @@
 	g_ConfigDB.WriteFile(CFG_USER);
 }
 
+unsigned int GetVersionNumber(void* UNUSED(cbdata))
+{
+	unsigned int versionNumber = 0;
+	CFG_GET_VAL("versionNumber", UnsignedInt, versionNumber);
+	return versionNumber;
+}
 
+std::string GetVersionNumberString(void* UNUSED(cbdata))
+{
+	std::string versionNumberString = "";
+	CFG_GET_VAL("versionNumberString", String, versionNumberString);
+	return versionNumberString;
+}
+
+std::string GetVersionName(void* UNUSED(cbdata))
+{
+	std::string versionName = "";
+	CFG_GET_VAL("versionName", String, versionName);
+	return versionName;
+}
+
+
 void SetUserReportEnabled(void* UNUSED(cbdata), bool enabled)
 {
 	g_UserReporter.SetReportingEnabled(enabled);
@@ -721,6 +742,11 @@
 	scriptInterface.RegisterFunction<bool, &IsSplashScreenEnabled>("IsSplashScreenEnabled");
 	scriptInterface.RegisterFunction<void, bool, &SetSplashScreenEnabled>("SetSplashScreenEnabled");
 
+	// Version data functions
+	scriptInterface.RegisterFunction<unsigned int, &GetVersionNumber>("GetVersionNumber");
+	scriptInterface.RegisterFunction<std::string, &GetVersionNumberString>("GetVersionNumberString");
+	scriptInterface.RegisterFunction<std::string, &GetVersionName>("GetVersionName");
+
 	// Development/debugging functions
 	scriptInterface.RegisterFunction<void, float, &SetSimRate>("SetSimRate");
 	scriptInterface.RegisterFunction<float, &GetSimRate>("GetSimRate");