Index: binaries/data/mods/public/gui/pregame/mainmenu.xml
===================================================================
--- binaries/data/mods/public/gui/pregame/mainmenu.xml	(revision 13808)
+++ binaries/data/mods/public/gui/pregame/mainmenu.xml	(working copy)
@@ -440,17 +440,18 @@
 
 				<!-- PRE-RELEASE WARNING -->
 				<object
+					name="preReleaseWarning"
 					font="serif-14"
 					type="text"
 					textcolor="white"
 					size="8 8 100%-8 100%-36"
                                         ghost="true"
 				>
-[font="serif-bold-16"]Alpha XIV: Naukratis<!-- IMPORTANT: remember to update session/session.xml in sync with this -->[/font]
-
-WARNING: This is an early development version of the game. Many features have not been added yet.
-
-Get involved at: play0ad.com
+				<action on="Load">
+					this.caption = "[font=\"serif-bold-16\"]Alpha " + Engine.GetVersionNumberString() + " : " + Engine.GetVersionName() + "[/font]\n\n" +
+					"WARNING: This is an early development version of the game. Many features have not been added yet.\n\n" +
+					"Get involved at: play0ad.com"
+				</action>
 				</object>
 
 				<!-- FUNDRAISER -->
Index: binaries/data/mods/public/gui/session/session.xml
===================================================================
--- binaries/data/mods/public/gui/session/session.xml	(revision 13808)
+++ binaries/data/mods/public/gui/session/session.xml	(working copy)
@@ -615,7 +615,7 @@
 
 	    <!-- Displays Alpha name and number -->
 	    <object size="50%+48 0 100%-226 100%" name="alphaLabel" type="text" style="CenteredLabelText" text_valign="top" ghost="true">
-		ALPHA XIV : Naukratis<!-- IMPORTANT: remember to update pregame/mainmenu.xml in sync with this -->
+			<action on="Load">this.caption= "Alpha " + Engine.GetVersionNumberString() + " : " + Engine.GetVersionName()</action>
 
 		<!-- Displays build date and revision number-->
 		<object size="50%-128 0 50%+128 100%-2" name="buildTimeLabel" type="text" style="BuildNameText" ghost="true">
Index: source/gui/scripting/ScriptFunctions.cpp
===================================================================
--- source/gui/scripting/ScriptFunctions.cpp	(revision 13808)
+++ source/gui/scripting/ScriptFunctions.cpp	(working copy)
@@ -43,6 +43,7 @@
 #include "ps/UserReport.h"
 #include "ps/GameSetup/Atlas.h"
 #include "ps/GameSetup/Config.h"
+#include "ps/GameSetup/VersionData.h"
 #include "ps/ConfigDB.h"
 #include "tools/atlas/GameInterface/GameLoop.h"
 
@@ -537,7 +538,22 @@
 	g_ConfigDB.WriteFile(CFG_USER);
 }
 
+unsigned int GetVersionNumber(void* UNUSED(cbdata))
+{
+	return g_VersionNumber;
+}
 
+std::string GetVersionNumberString(void* UNUSED(cbdata))
+{
+	return g_VersionNumberString;
+}
+
+std::string GetVersionName(void* UNUSED(cbdata))
+{
+	return g_VersionName;
+}
+
+
 void SetUserReportEnabled(void* UNUSED(cbdata), bool enabled)
 {
 	g_UserReporter.SetReportingEnabled(enabled);
@@ -721,6 +737,11 @@
 	scriptInterface.RegisterFunction<bool, &IsSplashScreenEnabled>("IsSplashScreenEnabled");
 	scriptInterface.RegisterFunction<void, bool, &SetSplashScreenEnabled>("SetSplashScreenEnabled");
 
+	// Version data functions
+	scriptInterface.RegisterFunction<unsigned int, &GetVersionNumber>("GetVersionNumber");
+	scriptInterface.RegisterFunction<std::string, &GetVersionNumberString>("GetVersionNumberString");
+	scriptInterface.RegisterFunction<std::string, &GetVersionName>("GetVersionName");
+
 	// Development/debugging functions
 	scriptInterface.RegisterFunction<void, float, &SetSimRate>("SetSimRate");
 	scriptInterface.RegisterFunction<float, &GetSimRate>("GetSimRate");
Index: source/ps/GameSetup/VersionData.cpp
===================================================================
--- source/ps/GameSetup/VersionData.cpp	(revision 0)
+++ source/ps/GameSetup/VersionData.cpp	(working copy)
@@ -0,0 +1,27 @@
+/* Copyright (C) 2013 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "VersionData.h"
+
+/* Release version and all version information (such as name and number) shall be gathered in this file*/
+
+unsigned int g_VersionNumber = 14;
+std::string g_VersionNumberString = "XIV";
+std::string g_VersionName = "Naukratis";
+
Index: source/ps/GameSetup/VersionData.h
===================================================================
--- source/ps/GameSetup/VersionData.h	(revision 0)
+++ source/ps/GameSetup/VersionData.h	(working copy)
@@ -0,0 +1,25 @@
+/* Copyright (C) 2013 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef INCLUDED_PS_GAMESETUP_VERSIONDATA
+#define INCLUDED_PS_GAMESETUP_VERSIONDATA
+
+extern unsigned int g_VersionNumber;
+extern std::string g_VersionNumberString;
+extern std::string g_VersionName;
+
+#endif // INCLUDED_PS_GAMESETUP_VERSIONDATA
\ No newline at end of file